%bcond_without check
%global ts_commit 89cc463fa1251449d7974086a34ef0dc100b1582
%global ts_shortcommit %(c=%{ts_commit}; echo ${c:0:7})

Summary: The WebAssembly Binary Toolkit
Name: wabt
Version: 1.0.10
Release: 2%{?dist}
URL: https://github.com/WebAssembly/wabt
Source0: https://github.com/WebAssembly/wabt/archive/%{version}/%{name}-%{version}.tar.gz
Source1: https://github.com/WebAssembly/testsuite/archive/%{ts_commit}/%{name}-testsuite-%{ts_shortcommit}.tar.gz
# https://github.com/WebAssembly/wabt/issues/1042
Patch0: wabt-cmake.patch
# Build against system gtest
Patch1: wabt-gtest.patch
# https://github.com/WebAssembly/wabt/pull/1046
Patch100: 0001-Canonicalize-NaNs-in-the-interpreter-1046.patch
License: ASL 2.0
BuildRequires: cmake
BuildRequires: gcc-c++
%if %{with check}
BuildRequires: gtest-devel
BuildRequires: python-ply
%endif

%description
WABT (we pronounce it "wabbit") is a suite of tools for WebAssembly. These tools
are intended for use in (or for development of) toolchains or other systems that
want to manipulate WebAssembly files. Unlike the WebAssembly spec interpreter
(which is written to be as simple, declarative and "speccy" as possible), they
are written in C/C++ and designed for easier integration into other systems.
Unlike Binaryen these tools do not aim to provide an optimization platform or a
higher-level compiler target; instead they aim for full fidelity and compliance
with the spec (e.g. 1:1 round-trips with no changes to instructions).

%prep
%autosetup -p1
%if %{with check}
rmdir third_party/testsuite
tar xzf %{S:1} -C third_party
mv third_party/testsuite{-%{ts_commit},}
pushd test
# https://github.com/WebAssembly/wabt/issues/1044
# https://github.com/WebAssembly/wabt/issues/1045
# https://github.com/WebAssembly/wabt/issues/1063
pushd wasm2c/spec
%ifarch i686 ppc64 ppc64le
rm conversions.txt
%endif
%ifarch i686
rm \
  float_exprs.txt\
  float_literals.txt\
  float_memory.txt\
  float_misc.txt\

%endif
popd
%ifarch ppc64
rm spec/{conversions.txt,nontrapping-float-to-int-conversions/conversions.txt}
%endif
%ifarch ppc64 ppc64le
rm wasm2c/spec/f{32,64}.txt
%endif
popd
%endif

%build
# work around https://github.com/WebAssembly/wabt/issues/988
mkdir -p build
cd build
%cmake ..
%make_build

%install
cd build
%make_install

%if %{with check}
# ~250 tests fail on big-endian arches
%ifnarch ppc64 s390x
%check
test/run-tests.py -v --timeout=20 %{?_smp_mflags}
%endif
%endif

%files
%license LICENSE
%doc README.md
%{_bindir}/spectest-interp
%{_bindir}/wasm-interp
%{_bindir}/wasm-objdump
%{_bindir}/wasm-opcodecnt
%{_bindir}/wasm-strip
%{_bindir}/wasm-validate
%{_bindir}/wasm2c
%{_bindir}/wasm2wat
%{_bindir}/wast2json
%{_bindir}/wat-desugar
%{_bindir}/wat2wasm
%{_mandir}/man1/spectest-interp.1*
%{_mandir}/man1/wasm-interp.1*
%{_mandir}/man1/wasm-objdump.1*
%{_mandir}/man1/wasm-opcodecnt.1*
%{_mandir}/man1/wasm-strip.1*
%{_mandir}/man1/wasm-validate.1*
%{_mandir}/man1/wasm2c.1*
%{_mandir}/man1/wasm2wat.1*
%{_mandir}/man1/wast2json.1*
%{_mandir}/man1/wat-desugar.1*
%{_mandir}/man1/wat2wasm.1*

%changelog
* Mon Apr 15 2019 Dominik Mierzejewski <rpm@greysector.net> 1.0.10-2
- backport some fixes for test failures from upstream git
- run tests in parallel and double timeout to prevent failures on armv7hl

* Thu Mar 14 2019 Dominik Mierzejewski <rpm@greysector.net> 1.0.10-1
- initial build
